Imports System
Imports System.ComponentModel

Imports DevExpress.Xpo
Imports DevExpress.Data.Filtering

Imports DevExpress.ExpressApp
Imports DevExpress.Persistent.Base
Imports DevExpress.Persistent.BaseImpl
Imports DevExpress.Persistent.Validation

<DefaultClassOptions(), NavigationItem(False), CreatableItem(False), DeferredDeletion(False)> _
Public Class ModelListView
    Inherits BaseObject
    Private _MasterObject As Guid
    Private _EditorType As String
    Private _IsFooterVisible As Boolean
    Private _IsGroupPanelVisible As Boolean
    Private _ShowAutoFilterRow As Boolean
    Private _ShowFindPanel As Boolean
    Private _Id As String
    Private _PivotSettings As String
    Public Sub New(ByVal session As Session)
        MyBase.New(session)
        ' This constructor is used when an object is loaded from a persistent storage.
        ' Do not place any code here or place it only when the IsLoading property is false:
        ' if (!IsLoading){
        '   It is now OK to place your initialization code here.
        ' }
        ' or as an alternative, move your initialization code into the AfterConstruction method.
    End Sub
    Public Overrides Sub AfterConstruction()
        MyBase.AfterConstruction()
        ' Place here your initialization code.
    End Sub

    Property MasterObject As Guid
        Get
            Return _MasterObject
        End Get
        Set(value As Guid)
            SetPropertyValue("MasterObject", _MasterObject, value)
        End Set
    End Property
    <Size(255)> _
    Property EditorType As String
        Get
            Return _EditorType
        End Get
        Set(value As String)
            SetPropertyValue("EditorType", _EditorType, value)
        End Set
    End Property
    Property IsFooterVisible As Boolean
        Get
            Return _IsFooterVisible
        End Get
        Set(value As Boolean)
            SetPropertyValue("IsFooterVisible", _IsFooterVisible, value)
        End Set
    End Property
    Property IsGroupPanelVisible As Boolean
        Get
            Return _IsGroupPanelVisible
        End Get
        Set(value As Boolean)
            SetPropertyValue("IsGroupPanelVisible", _IsGroupPanelVisible, value)
        End Set
    End Property
    Property ShowAutoFilterRow As Boolean
        Get
            Return _ShowAutoFilterRow
        End Get
        Set(value As Boolean)
            SetPropertyValue("ShowAutoFilterRow", _ShowAutoFilterRow, value)
        End Set
    End Property
    Property ShowFindPanel As Boolean
        Get
            Return _ShowFindPanel
        End Get
        Set(value As Boolean)
            SetPropertyValue("ShowFindPanel", _ShowFindPanel, value)
        End Set
    End Property
    <Size(255)> _
    Property Id As String
        Get
            Return _Id
        End Get
        Set(value As String)
            SetPropertyValue("Id", _Id, value)
        End Set
    End Property
    <Size(-1)> _
    Property PivotSettings As String
        Get
            Return _PivotSettings
        End Get
        Set(value As String)
            SetPropertyValue("PivotSettings", _PivotSettings, value)
        End Set
    End Property

    ReadOnly Property ModelListViewColumn As XPCollection(Of ModelListViewColumn)
        Get
            Return New XPCollection(Of ModelListViewColumn)(Session, CriteriaOperator.Parse("ModelListView=?", Me))
        End Get
    End Property
End Class
